#include "Point.h"

PointSet::PointSet(const char* filename)
{
	ifstream in(filename);
	if (!in.is_open() || in.bad()) std::cerr << "PointSet error: file " << *filename << " could not be opened\n";
  	
	// _name = nom du fichier, sans l'extension
	_name = new char[100];
	strcpy(_name,filename);
	char* pc;
	pc = _name;
	while ((*pc != '\0') && (*pc != '.')) pc++;
	*pc = '\0';
	
	// Parcours du fichier
	_buffer.clear();
	unsigned int id, nb;
	float x,y;
  	char c = in.peek();
    	if (c == ' ' || c == '\n') in.get();
    	else if (c == '#') {
      		char comment[1000];
      		in.getline(comment, 1000);
    	}
	else {
      		in >> nb; // Nombre de points de l'ensemble
	}
        for (unsigned int i = 0; i < nb; i++) {
		in >> id;
		in >> x;
		in >> y;
		Point* np = new Point(x,y,id);
		_buffer.push_back(np); 
	}
	in.close();
}

PointSet::~PointSet()
{
	if (_name != NULL) delete [] _name;
	for (list<Point*>::iterator it_point = _buffer.begin(); it_point != _buffer.end(); it_point++) delete *it_point;
}
