#ifndef _Point_h_
#define _Point_h_

#include <list>
#include <iostream>
#include <fstream>

/* Dfinition des classes Point et PointSet */

using namespace std;

class PointSet;

class Point
// Un point
{
  private:
  	// Coordonnes du point
	float _x;
	float _y;
  
  	// Identifiant
	unsigned int _id;
	
  public:
  	// Constructeur par dfaut
	Point() : _x(0.0), _y(0.0), _id(0) { }
	
	// Constructeur  partir de coordonnes et d'un identificateur
	Point(float x, float y, unsigned int i) : _x(x), _y(y), _id(i) { }
	
	// Accesseurs
	float GetX() { return _x; }
	float GetY() { return _y; }
	unsigned int GetId() { return _id; }
};

class PointSet
// L'ensemble des points, stocks dans une liste
{
  private:
  	// Les points de l'ensemble
	list<Point*> _buffer;
	
	// Nom de l'ensemble de points (en fait du fichier source)
	char* _name;

  public:
  	// Constructeur par dfaut
	PointSet() : _name(NULL) { _buffer.clear(); }
	
	// Constructeur  partir d'un fichier
	PointSet(const char* filename);
	
	// Accesseurs
	list<Point*> GetList() { return _buffer; }
	char* GetName() { return _name; }
	
	// Destructeur
	~PointSet();
};

#endif
