#include "Triangle.h"

void Triangulation::RemoveTriangle(Triangle* t)
{
	list<Triangle*>::iterator it_triangle = find(_buffer.begin(),_buffer.end(),t);
	if (it_triangle != _buffer.end()) _buffer.erase(it_triangle);
	else cerr << "Triangulation error: trying to remove a missing triangle" << endl;
}

Triangulation::~Triangulation()
{
	for (list<Triangle*>::iterator it_triangle = _buffer.begin(); it_triangle != _buffer.end(); it_triangle++) delete *it_triangle;
}

void Triangulation::CreateFile()
{
	// filename = _name + extension .ele
	char* filename;
	filename = new char[100];
	strcpy(filename,_name);
	strcat(filename,".ele");
	
	// Remplissage du fichier
	ofstream out(filename);
	out << _buffer.size() << endl;
	int id = 1;
	for (list<Triangle*>::const_iterator it_triangle = _buffer.begin(); it_triangle != _buffer.end(); it_triangle++) {
		out << id << ' ' << (*it_triangle)->GetPoint1()->GetId() << ' ' << (*it_triangle)->GetPoint2()->GetId() << ' ' << (*it_triangle)->GetPoint3()->GetId() << endl;
		id++; // Le format <ele> rclame un identifiant par face
	}
	out.close();
}
