#ifndef _Triangle_h_
#define _Triangle_h_

#include "Point.h"

/* Dfinition des classes Triangle et Triangulation */

class Triangulation;

class Triangle
// Un triangle
{
  private:
  	// Les 3 extrmits
	Point* _p1;
	Point* _p2;
	Point* _p3;
	
	
  public:
  	// Constructeur par dfaut
	Triangle() : _p1(NULL), _p2(NULL), _p3(NULL) { }
	
	// Constructeur  partir de 3 points
	Triangle(Point* p1, Point* p2, Point* p3) : _p1(p1), _p2(p2), _p3(p3) { }

	// Accesseurs
	Point* GetPoint1() { return _p1; }
	Point* GetPoint2() { return _p2; }
	Point* GetPoint3() { return _p3; }
};

class Triangulation
// Une triangulation d'un ensemble de points
// Les triangles sont stocks dans une liste
{
  private:
  	// Les triangles de l'ensemble
	list<Triangle*> _buffer;
	
	// Nom de la triangulation
	char* _name;

  public:
  	// Constructeur par dfaut
	Triangulation() : _name(NULL) { _buffer.clear(); }
	
	// Accesseur
	list<Triangle*> GetList() { return _buffer; }
	
	// Mutateurs
	void AddTriangle(Triangle* t) { _buffer.push_back(t); }
	void RemoveTriangle(Triangle* t);
	void SetName(char* name) { _name = name; }
	
	// Destructeur
	~Triangulation();
	
	// Cration du fichier .ele
	void CreateFile();
};

#endif
