#include <math.h>
#include "Triangle.h"

// Cration de la triangulation de Delaunay,
// selon l'algorithme de Guibas-Knuth-Sharir
int main(int argc, char** argv) {
	// Lecture d'un fichier de points
	PointSet myPointSet(argv[1]);
	list<Point*> myPointList = myPointSet.GetList();
	int NumberOfPoints = myPointList.size();

	// Cration d'une triangulation vide
	Triangulation myTriangulation;
	myTriangulation.SetName(myPointSet.GetName());
	
	// Etape 1 : cration d'un grand triangle englobant myPointSet
	// => c'est la triangulation initiale
	float xmin, xmax, ymin, ymax;
	xmin = (myPointList.front())->GetX();
	xmax = xmin;
	ymin = (myPointList.front())->GetY();
	ymax = ymin;
	for (list<Point*>::const_iterator it_point = myPointList.begin(); it_point != myPointList.end(); it_point++) {
		if ((*it_point)->GetX() < xmin) xmin = (*it_point)->GetX();
		if ((*it_point)->GetX() > xmax) xmax = (*it_point)->GetX();
		if ((*it_point)->GetY() < ymin) ymin = (*it_point)->GetY();
		if ((*it_point)->GetY() > ymax) ymax = (*it_point)->GetY();
	}
	Point* border1 = new Point(2*xmin-xmax,2*ymin-ymax,NumberOfPoints+1);
	Point* border2 = new Point(2*xmin-xmax,3*ymax-2*ymin,NumberOfPoints+2);
	Point* border3 = new Point(3*xmax-2*xmin,2*ymin-ymax,NumberOfPoints+3);
	Triangle* border = new Triangle(border1,border2,border3);
	myTriangulation.AddTriangle(border);
	
	// Etape 2 : boucle sur les points de myPointSet
	for (list<Point*>::const_iterator it_point = myPointList.begin(); it_point != myPointList.end(); it_point++) {
		// Etape 2.a : choix alatoire d'un point P : ici on prend les points dans l'ordre de la liste, donc P = *it_point
		
		// Etape 2.b : trouver le triangle ABC de myTriangulation qui contient *it_point
		Triangle* ABC;
		/* A COMPLETER (utiliser un DAG) */
		
		// Etape 2.c : supprimer ABC et ajouter trois nouveaux triangles PAB, PBC, PCA
		Point* A = ABC->GetPoint1();
		Point* B = ABC->GetPoint2();
		Point* C = ABC->GetPoint3();
		Triangle* PAB = new Triangle(it_point,A,B);
		Triangle* PBC = new Triangle(it_point,B,C);
		Triangle* PCA = new Triangle(it_point,C,A);
		myTriangulation.RemoveTriangle(ABC);
		myTriangulation.AddTriangle(PAB);
		myTriangulation.AddTriangle(PBC);
		myTriangulation.AddTriangle(PCA);
		delete ABC; // ABC n'apparatra plus dans la triangulation
		/* A COMPLETER : mettre  jour le DAG */
		
		Point* X = A;
		
		// Etape 2.d : boucle repeat...until
		
		/* A COMPLETER (penser  mettre  jour le DAG) */
	}
	
	// Cration du fichier rsultat
	myTriangulation.CreateFile();
	
	return 0;
}
